/*
 * ,m6Y=,:.gM##Od###a,:?"DGK   Generalitat de Catalunya
 * .#J=.dNJ7M#F` H#P!JMx,T?b
 * J1!.M##  M#F  #Hr ,##N,iW
 * J!d3H##  M#F  ##r ,##L4,?   CTTI
 *  .t\d##` M#F  ##r ,#H:lH,   Canigo
 * .#` d##  MHF` #Hr ,##:,,b
 * .Fr d##  M#F  ##r ,#H: cN   http://www.gencat.net/
 * ,F\ d##  M#F  ##r ,##: l#
 * .Nj d##  M#F` #Hr ,##:.+F
 *  Xc;d##` MHF  ##r ,##:2d!   Aquest codi s propietat de la Generalitat de
 * ,.W,d##  M#F  ##r ,##2J$.   Catalunya. La seva distribuci est prohibida
 * JJ,4H##  M#F` ##r`,##d3`J   sense el seu consentiment
 * ,N..?M#1.M#F  #HL.w#Y...F
 * .@Ja,:,TWM##1O##NT".?.sJK   2007, Tots els drets reservats
 */
package net.gencat.ctti.canigo.samples.prototip.model.bo.impl;

import java.util.List;

import net.gencat.ctti.canigo.samples.prototip.model.Category;
import net.gencat.ctti.canigo.samples.prototip.model.bo.CategoryBO;
import net.gencat.ctti.canigo.services.persistence.HibernateDAO;
import net.gencat.ctti.canigo.services.persistence.UniversalHibernateDAO;

import org.apache.commons.beanutils.BeanUtils;


/**
 * Documentaci.
 *
 * @author $author$
 * @version $Revision: 1.4 $
  */
public class CategoryBOImpl implements CategoryBO {
   /**
    * Documentaci.
    */
   UniversalHibernateDAO dao;

   /**
    * Creates a new CategoryBOImpl object.
    */
   public CategoryBOImpl() {
      super();
   }

   /**
    * Documentaci.
    */
   public void test() {
      System.out.println("------------> test");
   }

   /**
    * Documentaci.
    *
    * @param id Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public Category getCategoryById(String id) throws Exception {
      return (Category) dao.get(Category.class, id);
   }

   /**
    * Documentaci.
    *
    * @param category Documentaci
    *
    * @throws Exception Documentaci
    */
   public void save(Category category) throws Exception {
      // First try to see if exists the category
      //Category tmpCategory = new Category();
      //BeanUtils.copyProperties(tmpCategory,category);

      //dao.refresh(category);
      //BeanUtils.copyProperties(category,tmpCategory);		
      this.test();
      dao.save(category);
   }

   /**
    * Documentaci.
    *
    * @param category Documentaci
    *
    * @throws Exception Documentaci
    */
   public void update(Category category) throws Exception {
      this.test();

      Category tmpCategory = new Category();
      tmpCategory.setId(category.getId());
      BeanUtils.copyProperties(tmpCategory, category);
      //		
      dao.refresh(tmpCategory);
      BeanUtils.copyProperties(tmpCategory, category);
      //		categoryDAO.refresh(tmpCategory);
      //		BeanUtils.c
      System.out.println("Update");
      dao.update(tmpCategory);
   }

   /**
    * Documentaci.
    *
    * @param category Documentaci
    *
    * @throws Exception Documentaci
    */
   public void delete(Category category) throws Exception {
      this.test();
      dao.delete(category);
   }

   /**
    * Documentaci.
    *
    * @param category Documentaci
    *
    * @return Documentaci
    */
   public Category load(Category category) {
      this.test();
      dao.refresh(category);

      return category;
   }

   /**
    * Documentaci.
    *
    * @param category Documentaci
    *
    * @return Documentaci
    */
   public Category refresh(Category category) {
      this.test();
      dao.refresh(category);

      return category;
   }

   /**
    * Documentaci.
    *
    * @param category Documentaci
    *
    * @throws Exception Documentaci
    */
   public void saveOrUpdate(Category category) throws Exception {
      this.test();
      dao.saveOrUpdate(category);
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public List findAll() {
      return ((UniversalHibernateDAO) (dao)).findAll(Category.class);
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public UniversalHibernateDAO getDao() {
      return dao;
   }

   /**
    * Documentaci.
    *
    * @param dao Documentaci
    */
   public void setDao(UniversalHibernateDAO dao) {
      this.dao = dao;
   }
}
