/*
 * ,m6Y=,:.gM##Od###a,:?"DGK   Generalitat de Catalunya
 * .#J=.dNJ7M#F` H#P!JMx,T?b
 * J1!.M##  M#F  #Hr ,##N,iW
 * J!d3H##  M#F  ##r ,##L4,?   CTTI
 *  .t\d##` M#F  ##r ,#H:lH,   Canigo
 * .#` d##  MHF` #Hr ,##:,,b
 * .Fr d##  M#F  ##r ,#H: cN   http://www.gencat.net/
 * ,F\ d##  M#F  ##r ,##: l#
 * .Nj d##  M#F` #Hr ,##:.+F
 *  Xc;d##` MHF  ##r ,##:2d!   Aquest codi s propietat de la Generalitat de
 * ,.W,d##  M#F  ##r ,##2J$.   Catalunya. La seva distribuci est prohibida
 * JJ,4H##  M#F` ##r`,##d3`J   sense el seu consentiment
 * ,N..?M#1.M#F  #HL.w#Y...F
 * .@Ja,:,TWM##1O##NT".?.sJK   2007, Tots els drets reservats
 */
package net.gencat.ctti.canigo.samples.prototip.struts.action;

import java.util.List;

import net.gencat.ctti.canigo.samples.prototip.model.Mail;
import net.gencat.ctti.canigo.samples.prototip.model.bo.MailBO;
import net.gencat.ctti.canigo.samples.prototip.web.spring.view.document.XMLView;
import net.gencat.ctti.canigo.services.mail.MailService;
import net.gencat.ctti.canigo.services.web.lists.ValueListActionHelper;
import net.gencat.ctti.canigo.services.web.struts.DispatchActionSupport;
import net.gencat.ctti.canigo.services.web.struts.SpringBindingActionForm;
import net.gencat.ctti.canigo.services.xml.XMLSerializationService;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


/**
 * Documentaci.
 *
 * @author $author$
 * @version $Revision: 1.2 $
  */
public class MailAction extends DispatchActionSupport {
   /**
    * Documentaci.
    */
   private net.gencat.ctti.canigo.samples.prototip.model.bo.MailBO mailBO;

   /**
    * Documentaci.
    */
   private MailService mailService;

   /**
    * Documentaci.
    */
   private ValueListActionHelper valueListActionHelper;

   /**
    * Documentaci.
    */
   private XMLSerializationService serializationService;

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward create(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      return mapping.findForward("create");
   }

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward edit(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
      Mail vo = (Mail) actionForm.getTarget();

      if (vo.getId() != null) {
         mailBO.refresh(vo);
      }

      return mapping.findForward("edit");
   }

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward cancel(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      return mapping.findForward("success");
   }

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward send(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
      Mail vo = (Mail) actionForm.getTarget();
      this.logService.getLog(this.getClass())
                     .debug("Sending mail from " + vo.getFromAddress() +
         " with subject " + vo.getSubject() + " and message " +
         vo.getMessage() + " to " + vo.getToAddress());
      this.mailService.send(vo.getFromAddress(), vo.getSubject(),
         vo.getMessage(), false, vo.getToAddress());
      this.mailBO.save((Mail) actionForm.getTarget());

      return mapping.findForward("success");
   }

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward search(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      valueListActionHelper.search(mapping, form, request, response);

      return mapping.findForward("list");
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public MailBO getDao() {
      return mailBO;
   }

   /**
    * Documentaci.
    *
    * @param mailBO Documentaci
    */
   public void setDao(MailBO mailBO) {
      this.mailBO = mailBO;
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public ValueListActionHelper getValueListActionHelper() {
      return valueListActionHelper;
   }

   /**
    * Documentaci.
    *
    * @param valueListActionHelper Documentaci
    */
   public void setValueListActionHelper(
      ValueListActionHelper valueListActionHelper) {
      this.valueListActionHelper = valueListActionHelper;
   }

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward delete(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      SpringBindingActionForm actionForm = (SpringBindingActionForm) form;
      Mail vo = (Mail) actionForm.getTarget();
      this.logService.getLog(this.getClass())
                     .debug("Deleting Mail: " + vo.getId());

      if (vo.getId() != null) {
         mailBO.refresh(vo);
         mailBO.delete(vo);
      }

      return mapping.findForward("success");
   }

   /**
    * @return Returns the mailService.
    */
   public MailService getMailService() {
      return mailService;
   }

   /**
    * @param mailService The mailService to set.
    */
   public void setMailService(MailService mailService) {
      this.mailService = mailService;
   }

   /**
    * @return Returns the serializationService.
    */
   public XMLSerializationService getSerializationService() {
      return serializationService;
   }

   /**
    * @param serializationService The serializationService to set.
    */
   public void setSerializationService(
      XMLSerializationService serializationService) {
      this.serializationService = serializationService;
   }

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward searchExportXML(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      this.logService.getLog(this.getClass()).debug("Searching mails...");

      List list = ((MailBO) this.mailBO).findAll();
      this.logService.getLog(this.getClass())
                     .debug("La lista tiene " + list.size() + " elementos");

      if (list != null) {
         request.setAttribute(XMLView.XML_LIST, list);
      }

      if (serializationService != null) {
         request.setAttribute(XMLView.XML_SERIALIZATION_SERVICE,
            serializationService);
      }

      return mapping.findForward("xml");
   }
}
