/*
 * ,m6Y=,:.gM##Od###a,:?"DGK   Generalitat de Catalunya
 * .#J=.dNJ7M#F` H#P!JMx,T?b
 * J1!.M##  M#F  #Hr ,##N,iW
 * J!d3H##  M#F  ##r ,##L4,?   CTTI
 *  .t\d##` M#F  ##r ,#H:lH,   Canigo
 * .#` d##  MHF` #Hr ,##:,,b
 * .Fr d##  M#F  ##r ,#H: cN   http://www.gencat.net/
 * ,F\ d##  M#F  ##r ,##: l#
 * .Nj d##  M#F` #Hr ,##:.+F
 *  Xc;d##` MHF  ##r ,##:2d!   Aquest codi s propietat de la Generalitat de
 * ,.W,d##  M#F  ##r ,##2J$.   Catalunya. La seva distribuci est prohibida
 * JJ,4H##  M#F` ##r`,##d3`J   sense el seu consentiment
 * ,N..?M#1.M#F  #HL.w#Y...F
 * .@Ja,:,TWM##1O##NT".?.sJK   2007, Tots els drets reservats
 */
package net.gencat.ctti.canigo.samples.prototip.struts.action;

import net.gencat.ctti.canigo.samples.prototip.model.Account;
import net.gencat.ctti.canigo.samples.prototip.model.bo.AccountBO;
import net.gencat.ctti.canigo.services.web.struts.DispatchActionSupport;
import net.gencat.ctti.canigo.services.web.struts.SpringBindingActionForm;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


/**
 * Action example for Accounts
 * @author XES
 */
public class TabsAction extends DispatchActionSupport {
   /**
    * Documentaci.
    */
   private AccountBO accountBO = null;

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward edit(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      Account vo = (Account) ((SpringBindingActionForm) form).getTarget();
      vo.setId("ACID");
      accountBO.refresh(vo);

      return mapping.findForward("tab1");
   }

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward view(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      return mapping.findForward("tab2");
   }

   /**
    * @return Returns the accountBO.
    */
   public AccountBO getAccountDao() {
      return accountBO;
   }

   /**
    * @param accountBO The accountBO to set.
    */
   public void setAccountDao(AccountBO accountBO) {
      this.accountBO = accountBO;
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public AccountBO getAccountBO() {
      return accountBO;
   }

   /**
    * Documentaci.
    *
    * @param accountBO Documentaci
    */
   public void setAccountBO(AccountBO accountBO) {
      this.accountBO = accountBO;
   }
}
