/*
 * ,m6Y=,:.gM##Od###a,:?"DGK   Generalitat de Catalunya
 * .#J=.dNJ7M#F` H#P!JMx,T?b
 * J1!.M##  M#F  #Hr ,##N,iW
 * J!d3H##  M#F  ##r ,##L4,?   CTTI
 *  .t\d##` M#F  ##r ,#H:lH,   Canigo
 * .#` d##  MHF` #Hr ,##:,,b
 * .Fr d##  M#F  ##r ,#H: cN   http://www.gencat.net/
 * ,F\ d##  M#F  ##r ,##: l#
 * .Nj d##  M#F` #Hr ,##:.+F
 *  Xc;d##` MHF  ##r ,##:2d!   Aquest codi s propietat de la Generalitat de
 * ,.W,d##  M#F  ##r ,##2J$.   Catalunya. La seva distribuci est prohibida
 * JJ,4H##  M#F` ##r`,##d3`J   sense el seu consentiment
 * ,N..?M#1.M#F  #HL.w#Y...F
 * .@Ja,:,TWM##1O##NT".?.sJK   2007, Tots els drets reservats
 */
package net.gencat.ctti.canigo.samples.prototip.model.bo.impl;

import java.util.List;

import net.gencat.ctti.canigo.samples.prototip.model.Item;
import net.gencat.ctti.canigo.samples.prototip.model.bo.ItemBO;
import net.gencat.ctti.canigo.services.persistence.HibernateDAO;
import net.gencat.ctti.canigo.services.persistence.UniversalHibernateDAO;

import org.apache.commons.beanutils.BeanUtils;


/**
 * Documentaci.
 *
 * @author $author$
 * @version $Revision: 1.2 $
  */
public class ItemBOImpl implements ItemBO {
   /**
    * Documentaci.
    */
   UniversalHibernateDAO dao;

   /**
    * Creates a new ItemBOImpl object.
    */
   public ItemBOImpl() {
      super();
   }

   /**
    * Documentaci.
    */
   public void test() {
      System.out.println("------------> test");
   }

   /**
    * Documentaci.
    *
    * @param id Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public Item getItemById(String id) throws Exception {
      return (Item) dao.get(Item.class, id);
   }

   /**
    * Documentaci.
    *
    * @param item Documentaci
    *
    * @throws Exception Documentaci
    */
   public void save(Item item) throws Exception {
      // First try to see if exists the item
      //Item tmpItem = new Item();
      //BeanUtils.copyProperties(tmpItem,item);

      //dao.refresh(item);
      //BeanUtils.copyProperties(item,tmpItem);		
      this.test();
      dao.save(item);
   }

   /**
    * Documentaci.
    *
    * @param item Documentaci
    *
    * @throws Exception Documentaci
    */
   public void update(Item item) throws Exception {
      this.test();

      Item tmpItem = new Item();
      tmpItem.setId(item.getId());
      BeanUtils.copyProperties(tmpItem, item);
      //		
      dao.refresh(tmpItem);
      BeanUtils.copyProperties(tmpItem, item);
      //		itemDAO.refresh(tmpItem);
      //		BeanUtils.c
      System.out.println("Update");
      dao.update(tmpItem);
   }

   /**
    * Documentaci.
    *
    * @param item Documentaci
    *
    * @throws Exception Documentaci
    */
   public void delete(Item item) throws Exception {
      this.test();
      dao.delete(item);
   }

   /**
    * Documentaci.
    *
    * @param item Documentaci
    *
    * @return Documentaci
    */
   public Item load(Item item) {
      this.test();
      dao.refresh(item);

      return item;
   }

   /**
    * Documentaci.
    *
    * @param item Documentaci
    *
    * @return Documentaci
    */
   public Item refresh(Item item) {
      this.test();
      dao.refresh(item);

      return item;
   }

   /**
    * Documentaci.
    *
    * @param item Documentaci
    *
    * @throws Exception Documentaci
    */
   public void saveOrUpdate(Item item) throws Exception {
      this.test();
      dao.saveOrUpdate(item);
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public List findAll() {
      return ((HibernateDAO) (dao)).findAll();
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public UniversalHibernateDAO getDao() {
      return dao;
   }

   /**
    * Documentaci.
    *
    * @param dao Documentaci
    */
   public void setDao(UniversalHibernateDAO dao) {
      this.dao = dao;
   }
}
