/*
 * ,m6Y=,:.gM##Od###a,:?"DGK   Generalitat de Catalunya
 * .#J=.dNJ7M#F` H#P!JMx,T?b
 * J1!.M##  M#F  #Hr ,##N,iW
 * J!d3H##  M#F  ##r ,##L4,?   CTTI
 *  .t\d##` M#F  ##r ,#H:lH,   Canigo
 * .#` d##  MHF` #Hr ,##:,,b
 * .Fr d##  M#F  ##r ,#H: cN   http://www.gencat.net/
 * ,F\ d##  M#F  ##r ,##: l#
 * .Nj d##  M#F` #Hr ,##:.+F
 *  Xc;d##` MHF  ##r ,##:2d!   Aquest codi s propietat de la Generalitat de
 * ,.W,d##  M#F  ##r ,##2J$.   Catalunya. La seva distribuci est prohibida
 * JJ,4H##  M#F` ##r`,##d3`J   sense el seu consentiment
 * ,N..?M#1.M#F  #HL.w#Y...F
 * .@Ja,:,TWM##1O##NT".?.sJK   2007, Tots els drets reservats
 */
package net.gencat.ctti.canigo.samples.prototip.model.bo.impl;

import java.util.List;

import net.gencat.ctti.canigo.samples.prototip.model.Mail;
import net.gencat.ctti.canigo.samples.prototip.model.bo.MailBO;
import net.gencat.ctti.canigo.services.persistence.HibernateDAO;
import net.gencat.ctti.canigo.services.persistence.UniversalHibernateDAO;

import org.apache.commons.beanutils.BeanUtils;


/**
 * Documentaci.
 *
 * @author $author$
 * @version $Revision: 1.2 $
  */
public class MailBOImpl implements MailBO {
   /**
    * Documentaci.
    */
   UniversalHibernateDAO dao;

   /**
    * Creates a new MailBOImpl object.
    */
   public MailBOImpl() {
      super();
   }

   /**
    * Documentaci.
    */
   public void test() {
      System.out.println("------------> test");
   }

   /**
    * Documentaci.
    *
    * @param id Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public Mail getMailById(String id) throws Exception {
      return (Mail) dao.get(Mail.class, id);
   }

   /**
    * Documentaci.
    *
    * @param mail Documentaci
    *
    * @throws Exception Documentaci
    */
   public void save(Mail mail) throws Exception {
      // First try to see if exists the mail
      //Mail tmpMail = new Mail();
      //BeanUtils.copyProperties(tmpMail,mail);

      //dao.refresh(mail);
      //BeanUtils.copyProperties(mail,tmpMail);		
      this.test();
      dao.save(mail);
   }

   /**
    * Documentaci.
    *
    * @param mail Documentaci
    *
    * @throws Exception Documentaci
    */
   public void update(Mail mail) throws Exception {
      this.test();

      Mail tmpMail = new Mail();
      tmpMail.setId(mail.getId());
      BeanUtils.copyProperties(tmpMail, mail);
      //		
      dao.refresh(tmpMail);
      BeanUtils.copyProperties(tmpMail, mail);
      //		mailDAO.refresh(tmpMail);
      //		BeanUtils.c
      System.out.println("Update");
      dao.update(tmpMail);
   }

   /**
    * Documentaci.
    *
    * @param mail Documentaci
    *
    * @throws Exception Documentaci
    */
   public void delete(Mail mail) throws Exception {
      this.test();
      dao.delete(mail);
   }

   /**
    * Documentaci.
    *
    * @param mail Documentaci
    *
    * @return Documentaci
    */
   public Mail load(Mail mail) {
      this.test();
      dao.refresh(mail);

      return mail;
   }

   /**
    * Documentaci.
    *
    * @param mail Documentaci
    *
    * @return Documentaci
    */
   public Mail refresh(Mail mail) {
      this.test();
      dao.refresh(mail);

      return mail;
   }

   /**
    * Documentaci.
    *
    * @param mail Documentaci
    *
    * @throws Exception Documentaci
    */
   public void saveOrUpdate(Mail mail) throws Exception {
      this.test();
      dao.saveOrUpdate(mail);
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public List findAll() {
      return ((HibernateDAO) (dao)).findAll();
   }

   /**
    * Documentaci.
    *
    * @return Documentaci
    */
   public UniversalHibernateDAO getDao() {
      return dao;
   }

   /**
    * Documentaci.
    *
    * @param dao Documentaci
    */
   public void setDao(UniversalHibernateDAO dao) {
      this.dao = dao;
   }
}
