/*
 * ,m6Y=,:.gM##Od###a,:?"DGK   Generalitat de Catalunya
 * .#J=.dNJ7M#F` H#P!JMx,T?b
 * J1!.M##  M#F  #Hr ,##N,iW
 * J!d3H##  M#F  ##r ,##L4,?   CTTI
 *  .t\d##` M#F  ##r ,#H:lH,   Canigo
 * .#` d##  MHF` #Hr ,##:,,b
 * .Fr d##  M#F  ##r ,#H: cN   http://www.gencat.net/
 * ,F\ d##  M#F  ##r ,##: l#
 * .Nj d##  M#F` #Hr ,##:.+F
 *  Xc;d##` MHF  ##r ,##:2d!   Aquest codi s propietat de la Generalitat de
 * ,.W,d##  M#F  ##r ,##2J$.   Catalunya. La seva distribuci est prohibida
 * JJ,4H##  M#F` ##r`,##d3`J   sense el seu consentiment
 * ,N..?M#1.M#F  #HL.w#Y...F
 * .@Ja,:,TWM##1O##NT".?.sJK   2007, Tots els drets reservats
 */
package net.gencat.ctti.canigo.services.security.struts.action.admin;

import java.util.ArrayList;

import net.gencat.ctti.canigo.services.security.AuthorizationSecurityConfiguration;
import net.gencat.ctti.canigo.services.security.bo.admin.AdminBO;
import net.gencat.ctti.canigo.services.web.struts.DispatchActionSupport;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;


/**
 * Documentaci.
 *
 * @author $author$
 * @version $Revision: 1.2 $
  */
public abstract class SecurityAdminCRUDAction extends DispatchActionSupport {
   /**
    * Documentaci.
    */
   protected AdminBO adminBO = null;

   /**
    * Documentaci.
    */
   protected AuthorizationSecurityConfiguration configuration;

   /**
    * Documentaci.
    *
    * @param configuration Documentaci
    */
   public void setConfiguration(
      AuthorizationSecurityConfiguration configuration) {
      this.configuration = configuration;
   }

   /**
    * Documentaci.
    *
    * @param mapping Documentaci
    * @param form Documentaci
    * @param request Documentaci
    * @param response Documentaci
    *
    * @return Documentaci
    *
    * @throws Exception Documentaci
    */
   public ActionForward create(ActionMapping mapping, ActionForm form,
      javax.servlet.http.HttpServletRequest request,
      javax.servlet.http.HttpServletResponse response)
      throws Exception {
      return mapping.findForward("create");
   }

   /**
    * Documentaci.
    *
    * @param request Documentaci
    */
   protected void initializeCollections(
      javax.servlet.http.HttpServletRequest request) {
      request.setAttribute("applicationRolesCollection",
         this.adminBO.findAllApplicationRoles());
      request.setAttribute("availableRolesCollection",
         this.adminBO.findAllApplicationRoles());
      request.setAttribute("userSpecificRolesCollection", new ArrayList());
   }

   /**
    * @return Returns the adminBO.
    */
   public AdminBO getAdminBO() {
      return adminBO;
   }

   /**
    * @param adminBO The adminBO to set.
    */
   public void setAdminBO(AdminBO adminBO) {
      this.adminBO = adminBO;
   }

   /**
    * @return Returns the configuration.
    */
   public AuthorizationSecurityConfiguration getConfiguration() {
      return configuration;
   }
}
